DELIMITER $$
DROP PROCEDURE IF EXISTS cleanInstance$$
CREATE PROCEDURE cleanInstance(inst_state SMALLINT, lastActive DATETIME)
BEGIN
	DECLARE done INT DEFAULT FALSE;
	DECLARE i BIGINT;
    	DECLARE test_cus CURSOR FOR SELECT ID FROM ODE_PROCESS_INSTANCE WHERE INSTANCE_STATE = inst_state AND LAST_ACTIVE_TIME < lastActive;
	DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = TRUE;
    	OPEN test_cus;
	read_loop: LOOP
		IF done THEN
			LEAVE read_loop;
		END IF;
		FETCH test_cus INTO i;
        SELECT(' Start deleting instance data with instance id ' + i);
	START TRANSACTION;
	DELETE FROM ODE_EVENT WHERE INSTANCE_ID = i;
        DELETE FROM ODE_CORSET_PROP WHERE CORRSET_ID IN (SELECT cs.CORRELATION_SET_ID FROM ODE_CORRELATION_SET cs WHERE cs.SCOPE_ID IN (SELECT os.SCOPE_ID FROM ODE_SCOPE os WHERE	 os.PROCESS_INSTANCE_ID = i));
        DELETE FROM ODE_CORRELATION_SET WHERE SCOPE_ID IN (SELECT os.SCOPE_ID FROM ODE_SCOPE os WHERE os.PROCESS_INSTANCE_ID = i);
        DELETE FROM ODE_PARTNER_LINK WHERE SCOPE_ID IN (SELECT os.SCOPE_ID FROM ODE_SCOPE os WHERE os.PROCESS_INSTANCE_ID = i);
        DELETE FROM ODE_XML_DATA_PROP WHERE XML_DATA_ID IN (SELECT xd.XML_DATA_ID FROM ODE_XML_DATA xd WHERE xd.SCOPE_ID IN (SELECT os.SCOPE_ID FROM ODE_SCOPE os WHERE os.PROCESS_INSTANCE_ID = i));
        DELETE FROM ODE_XML_DATA WHERE SCOPE_ID IN (SELECT os.SCOPE_ID FROM ODE_SCOPE os WHERE os.PROCESS_INSTANCE_ID = i);
        DELETE FROM ODE_SCOPE WHERE PROCESS_INSTANCE_ID = i;
        DELETE FROM ODE_MEX_PROP WHERE MEX_ID IN (SELECT mex.MESSAGE_EXCHANGE_ID FROM ODE_MESSAGE_EXCHANGE mex WHERE mex.PROCESS_INSTANCE_ID = i);
        DELETE FROM ODE_MESSAGE WHERE MESSAGE_EXCHANGE_ID IN (SELECT mex.MESSAGE_EXCHANGE_ID FROM ODE_MESSAGE_EXCHANGE mex WHERE mex.PROCESS_INSTANCE_ID = i);
        DELETE FROM ODE_MESSAGE_EXCHANGE WHERE PROCESS_INSTANCE_ID = i;
        DELETE FROM ODE_MESSAGE_ROUTE WHERE PROCESS_INSTANCE_ID = i;
        DELETE FROM ODE_PROCESS_INSTANCE WHERE ID = i;
	COMMIT;
        SELECT(' End deleting instance data with instance id ' + i);	
    	END LOOP;
	CLOSE test_cus;
END$$
DELIMITER ;

SET @INST_STATE =30;
SELECT NOW() - INTERVAL 2 DAY INTO @LAST_ACTIVE; 
SELECT(' Starting cleanInstance procedure ');
CALL cleanInstance(@INST_STATE, @LAST_ACTIVE);
SELECT (' Ending cleanInstance procedure '); 


